<%@ page import="java.sql.*" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="javax.naming.InitialContext" %>
<%@ page import="java.lang.ThreadLocal" %>
<%@ page import="com.cforcoding.jmd.MarkDown" %>
<%@ page pageEncoding="UTF-8" %>
<%@ taglib uri="http://www.opensymphony.com/oscache" prefix="cache" %>
<%! 
	final String url = "jdbc:mysql://localhost/cppcms?useUnicode=yes&characterEncoding=UTF-8";
	ThreadLocal<Connection> connections = new ThreadLocal<Connection>();

	Connection getConnection() throws ClassNotFoundException, SQLException
	{
		Connection con = connections.get();
		if(con == null) {
			Class.forName("com.mysql.jdbc.Driver");
			con = DriverManager.getConnection(url,"root", "root");
			connections.set(con);
		}
		return con;
	}

	///
	/// This is mino markdown
	///
	static class Markdown {
		enum State {
			BLANK,
			PARA,
			LIST,
			QUOTE
		};

		private State state = State.BLANK;

		private StringBuilder out = null;

		private String input = null;

		private void setState(State s)
		{
			if(s==state)
				return;
			switch(state) {
			case PARA:
				out.append("</p>\n");
				break;
			case LIST:
				out.append("</ul>\n");
				break;
			case QUOTE:
				out.append("</blockquote>\n");
			}

			state = s;

			switch(state) {
			case PARA:
				out.append("<p>");
				break;
			case LIST:
				out.append("<ul>\n");
				break;
			case QUOTE:
				out.append("<blockquote>\n");
			}
		}

		Markdown()
		{
		}

		String convert(String in)
		{
			this.input = in;
			String result = new String();
			int len = input.length();
			out = new StringBuilder();
			out.ensureCapacity(len*11/10);
			int pos = 0;
			state = State.BLANK;
			while(pos < len) {
				int line_end = input.indexOf('\n',pos);
				if(line_end == -1)
					line_end = len;
				else
					line_end++;
				if(input.startsWith("#",pos)) {
					setState(State.BLANK);
					out.append("<h1>");
					processText(pos+1,line_end);
					out.append("</h1>\n");
				}
				else if(input.startsWith("-",pos)) {
					setState(State.LIST);
					out.append("<li>");
					processText(pos+1,line_end);
					out.append("</li>\n");
				}
				else if(input.startsWith(">",pos)) {
					setState(State.QUOTE);
					processText(pos+1,line_end);
					out.append("\n");
				}
				else {
					boolean is_blank = true;
					for(int i=pos;is_blank && i<line_end;i++) {
						char c = input.charAt(i);
						switch(c) {
						case ' ':
						case '\t':
						case '\n':
						case '\r':
							break;
						default:
							is_blank = false;
						}
					}
					if(is_blank)
						setState(State.BLANK);
					else { 
						setState(State.PARA);
						processText(pos,line_end);
						out.append("\n");
					}
				}
				pos = line_end;
			}
			setState(State.BLANK);
			return out.toString();
		}

		private void processText(int start,int end)
		{
			while(start < end && (input.charAt(start)==' ' || input.charAt(start)=='\t'))
				start++;
			for(int i=start;i<end;i++) {
				char c=input.charAt(i);
				switch(c) {
				case '<':
					out.append("&lt;");
					break;
				case '>':
					out.append("&gt;");
					break;
				case '&':
					out.append("&amp;");
					break;
				case '\r':
				case '\n':
					break;
				default:
					out.append(c);
				}
			}
		}
	}


	static String markdown(String source)
	{
		// Uncommend for JMD markdown
		//MarkDown proc = new MarkDown();
		//return proc.transform(source);

		// Uncomment for mini markdown
		return (new Markdown()).convert(source);
	}
%>
<cache:cache time="20" >
<% 
	String title="";
	String content = "";
	ArrayList<String> comments = new ArrayList<String>();

	try {

		Connection con = getConnection();
		Statement stmt = con.createStatement();
		try {
			String id = request.getParameter("id");
			ResultSet res = stmt.executeQuery(
				"SELECT	title,content " +
				"FROM	posts " +
				"WHERE id=" + id);
			if(res.next()) {
				title = res.getString(1);
				content = markdown(res.getString(2));
			}
			res = stmt.executeQuery(
				"SELECT content " +
				"FROM 	comments " +
				"WHERE  post_id = " + id + " " +
				"ORDER BY id ASC");
			while(res.next()) {
				comments.add(markdown(res.getString(1)));
			}
		}
		finally {
			stmt.close();
		}
	}
	catch( Exception e ) {
		out.println(e);
	}
%>
<html>
<title><%= title %></title>
<body>
	<h1><%= title %></h1>
	<%= content %>
	<ul>
	<% 
		for(String s : comments) {
			out.println("<li>" + s + "</li>");
		}
	%>
	</ul>
</body>
</html>
</cache:cache>
