<%@ Page Language="C#" %>
<%@ Assembly Name="MySql.Data" %>
<%@ Import namespace="System" %>
<%@ Import namespace="System.Data" %>
<%@ Import namespace="MySql.Data.MySqlClient" %>
<%@ Import namespace="System" %>
<%@ Import namespace="System.Collections" %>
<%@ Import namespace="System.Collections.Generic" %>
<%@ Import namespace="System.Security.Cryptography" %>
<%@ Import namespace="System.Text" %>
<%@ Import namespace="System.Text.RegularExpressions" %>
<%@ OutputCache Duration="15" VaryByParam="*" %>

<script runat="server" >

class Markdown {
	enum State {
		BLANK,
		PARA,
		LIST,
		QUOTE
	};

	private State state = State.BLANK;

	private StringBuilder outStream = null;

	private string input = null;

	private void setState(State s)
	{
		if(s==state)
			return;
		switch(state) {
		case State.PARA:
			outStream.Append("</p>\n");
			break;
		case State.LIST:
			outStream.Append("</ul>\n");
			break;
		case State.QUOTE:
			outStream.Append("</blockquote>\n");
			break;
		}

		state = s;

		switch(state) {
		case State.PARA:
			outStream.Append("<p>");
			break;
		case State.LIST:
			outStream.Append("<ul>\n");
			break;
		case State.QUOTE:
			outStream.Append("<blockquote>\n");
			break;
		}
	}

	public Markdown()
	{
	}

	public string convert(string inp)
	{
		this.input = inp;
		int len = input.Length;
		outStream = new StringBuilder();
		outStream.EnsureCapacity(len*11/10);
		int pos = 0;
		state = State.BLANK;
		while(pos < len) {
			int line_end = input.IndexOf('\n',pos);
			if(line_end == -1)
				line_end = len;
			else
				line_end++;
			if(input[pos]=='#') {
				setState(State.BLANK);
				outStream.Append("<h1>");
				processText(pos+1,line_end);
				outStream.Append("</h1>\n");
			}
			else if(input[pos]=='-') {
				setState(State.LIST);
				outStream.Append("<li>");
				processText(pos+1,line_end);
				outStream.Append("</li>\n");
			}
			else if(input[pos]=='>') {
				setState(State.QUOTE);
				processText(pos+1,line_end);
				outStream.Append("\n");
			}
			else {
				bool is_blank = true;
				for(int i=pos;is_blank && i<line_end;i++) {
					char c = input[i];
					switch(c) {
					case ' ':
					case '\t':
					case '\n':
					case '\r':
						break;
					default:
						is_blank = false;
						break;
					}
				}
				if(is_blank)
					setState(State.BLANK);
				else { 
					setState(State.PARA);
					processText(pos,line_end);
					outStream.Append("\n");
				}
			}
			pos = line_end;
		}
		setState(State.BLANK);
		return outStream.ToString();
	}

	private void processText(int start,int end)
	{
		while(start < end && (input[start]==' ' || input[start]=='\t'))
			start++;
		for(int i=start;i<end;i++) {
			char c=input[i];
			switch(c) {
			case '<':
				outStream.Append("&lt;");
				break;
			case '>':
				outStream.Append("&gt;");
				break;
			case '&':
				outStream.Append("&amp;");
				break;
			case '\r':
			case '\n':
				break;
			default:
				outStream.Append(c);
				break;
			}
		}
	}
}
</script>


<html>
<body>
<%
	{
		string connectionString =
			"Server=localhost;" +
			"Database=cppcms;" +
			"User ID=root;" +
			"Password=root;" +
			"Pooling=true;" +
			"charset=utf8";

		using(IDbConnection dbcon = new MySqlConnection(connectionString)) {
			dbcon.Open();
			using(IDbCommand dbcmd = dbcon.CreateCommand()) {
				// requires a table to be created named employee
				// with columns firstname and lastname
				// such as,
				//        CREATE TABLE employee (
				//           firstname varchar(32),
				//           lastname varchar(32));
				string id = Request["id"];
				string sql =
					"SELECT title,content " +
					"FROM posts where id=" + id;
				dbcmd.CommandText = sql;
				using(IDataReader reader = dbcmd.ExecuteReader()) {
					if(reader.Read()) {
						string title = reader.GetString(0);
						string content = reader.GetString(1);
						content = (new Markdown()).convert(content);
						Response.Write("<h1>" + title + "</h1>\n");
						Response.Write(content);
					}
				}
				dbcmd.CommandText = 
					"SELECT content " +
					"FROM comments " +
					"WHERE post_id = " + id + " " +
					"ORDER BY id ASC";
				using(IDataReader reader = dbcmd.ExecuteReader()) {
					Response.Write("<ul>");
					while(reader.Read()) {
						string content = reader.GetString(0);
						content = (new Markdown()).convert(content);
						Response.Write("<li>" + content + "</li>\n");
					}
					Response.Write("</ul>");
				}
			}
		}
	}
%>
</body>
</html>

